<#
.Description
    Questo script creerà un array di oggetti che contengono informazioni su ciascun disco, inclusa la lettera (DeviceID), la dimensione in GB e lo spazio libero in GB. L'array viene poi mostrato come una tabella formattata per una facile visualizzazione.
.Author
    Roberto Bonfa'
.Version
    2.1
#>
Import-Module Activedirectory

# Opzionale: Rimuovi per visualizzare gli errori
$ErrorActionPreference = "silentlycontinue"

try {
    $users = Get-ADUser -Filter 'Enabled -eq $true' -Properties DisplayName, MemberOf -SearchBase 'OU=IMG_Users,DC=netadmin,DC=local'

    $result = foreach ($user in $users) {
        $groupNames = $user.memberof | Get-ADGroup -Filter { Name -like 'APP_*' } | Select -ExpandProperty Name
        New-Object PSObject -Property @{
            UserName = $user.DisplayName
            Groups = ($groupNames -join ",")
        }
    }

    $result | Export-Csv -Path "C:\temp\report.csv" -NoTypeInformation
    Write-Host "Report esportato con successo."
} catch {
    Write-Host "Errore durante l'esecuzione dello script: $_"
}